diff -Naur src.pgsql/backend/executor/nodeBitmapAnd.c src.bitmap/backend/executor/nodeBitmapAnd.c
--- src.pgsql/backend/executor/nodeBitmapAnd.c	2006-09-16 17:51:41.000000000 -0700
+++ src.bitmap/backend/executor/nodeBitmapAnd.c	2006-09-17 00:09:24.000000000 -0700
@@ -80,14 +80,19 @@
 	 * call ExecInitNode on each of the plans to be executed and save the
 	 * results into the array "bitmapplanstates".
 	 */
+	bitmapandstate->isStream = (bool*)palloc(nplans);
 	i = 0;
 	foreach(l, node->bitmapplans)
 	{
 		initNode = (Plan *) lfirst(l);
-		bitmapplanstates[i] = ExecInitNode(initNode, estate, eflags);
+	    bitmapplanstates[i] = ExecInitNode(initNode, estate, eflags);
+		bitmapandstate->isStream[i] = true;
 		i++;
 	}
 
+	bitmapandstate->hashBitmap = NULL;
+	bitmapandstate->streamBitmap = NULL;
+
 	return bitmapandstate;
 }
 
@@ -112,7 +117,10 @@
 	PlanState **bitmapplans;
 	int			nplans;
 	int			i;
-	TIDBitmap  *result = NULL;
+	List		*streamBitmaps = NIL;
+	BlockNumber	blockno = InvalidBlockNumber;
+	bool		outputIsStream = false;
+	bool		isEmpty = false;
 
 	/* must provide our own instrumentation support */
 	if (node->ps.instrument)
@@ -124,46 +132,120 @@
 	bitmapplans = node->bitmapplans;
 	nplans = node->nplans;
 
-	/*
-	 * Scan all the subplans and AND their result bitmaps
-	 */
-	for (i = 0; i < nplans; i++)
+
+	while (true)
 	{
-		PlanState  *subnode = bitmapplans[i];
-		TIDBitmap  *subresult;
+		/*
+		 * Scan all the subplans and AND their result bitmaps
+ 		*/
+		for (i = 0; i < nplans; i++)
+		{
+			PlanState	*subnode = bitmapplans[i];
+			Node		*subresult = NULL;
 
-		subresult = (TIDBitmap *) MultiExecProcNode(subnode);
+			if (!node->isStream[i])
+				continue;
 
-		if (!subresult || !IsA(subresult, TIDBitmap))
-			elog(ERROR, "unrecognized result from subplan");
+			subresult = MultiExecProcNode(subnode);
+			if (subresult == NULL)
+			{
+				isEmpty = true;
+				break;
+			}
+
+			if (!(IsA(subresult, HashBitmap) ||
+				  IsA(subresult, StreamBitmap)))
+				elog(ERROR, "unrecognized result from subplan");
+
+			/* Intersect the hash bitmaps */
+			if (IsA(subresult, HashBitmap))
+			{
+				node->isStream[i] = false;
+
+				/* first subplan that generates a hash bitmap */
+				if (node->hashBitmap == NULL)
+					node->hashBitmap = (HashBitmap*) subresult;
+				else
+				{
+					tbm_intersect(node->hashBitmap, (HashBitmap*)subresult);
+					tbm_free((HashBitmap*)subresult);
+				}
+
+				/*
+				 * If at any stage we have a completely empty bitmap, we can fall out
+				 * without evaluating the remaining subplans, since ANDing them can no
+				 * longer change the result.  (Note: the fact that indxpath.c orders
+				 * the subplans by selectivity should make this case more likely to
+				 * occur.)
+				 */
+				if (tbm_is_empty(node->hashBitmap))
+				{
+					isEmpty = true;
+					break;
+				}
+			}
+			else
+			{
+				Assert(blockno == InvalidBlockNumber ||
+					   blockno == ((StreamBitmap*)subresult)->entry.blockno);
+				blockno = ((StreamBitmap*)subresult)->entry.blockno;
+				streamBitmaps = lappend(streamBitmaps, subresult);
+			}
+		}
 
-		if (result == NULL)
-			result = subresult; /* first subplan */
-		else
+		/* Intersect stream bitmaps if any. */
+		if (streamBitmaps != NIL)
 		{
-			tbm_intersect(result, subresult);
-			tbm_free(subresult);
+			if (node->hashBitmap != NULL)
+			{
+				StreamBitmap*	streamBitmap;
+				Assert(blockno != InvalidBlockNumber);
+				streamBitmap =
+					tbm_hash_to_stream(node->hashBitmap, blockno);
+
+				if (streamBitmap != NULL)
+					streamBitmaps = lappend(streamBitmaps, streamBitmap);
+				else
+				{
+					blockno = InvalidBlockNumber;
+					list_free(streamBitmaps);
+					streamBitmaps = NIL;
+					continue;
+				}
+			}
+
+			tbm_construct_stream_and(streamBitmaps, &(node->streamBitmap));
+			outputIsStream = true;
+
+			list_free(streamBitmaps);
+			streamBitmaps = NIL;
 		}
 
-		/*
-		 * If at any stage we have a completely empty bitmap, we can fall out
-		 * without evaluating the remaining subplans, since ANDing them can no
-		 * longer change the result.  (Note: the fact that indxpath.c orders
-		 * the subplans by selectivity should make this case more likely to
-		 * occur.)
-		 */
-		if (tbm_is_empty(result))
-			break;
+		break;
 	}
 
-	if (result == NULL)
-		elog(ERROR, "BitmapAnd doesn't support zero inputs");
-
 	/* must provide our own instrumentation support */
 	if (node->ps.instrument)
 		InstrStopNode(node->ps.instrument, 0 /* XXX */ );
 
-	return (Node *) result;
+	if (isEmpty)
+		return (Node*) NULL;
+
+	if (outputIsStream)
+		return (Node *) node->streamBitmap;
+	else
+	{
+		HashBitmap *hashBitmap = node->hashBitmap;
+
+		/*
+		 *set node->hashBitmap to NULL since this node will not be
+		 * called any more and its space will be re-claimed in its
+		 * parent node.
+		 */
+		node->hashBitmap = NULL;
+
+		return (Node*) hashBitmap;
+	}
 }
 
 /* ----------------------------------------------------------------
@@ -195,6 +277,14 @@
 		if (bitmapplans[i])
 			ExecEndNode(bitmapplans[i]);
 	}
+
+	pfree(node->isStream);
+
+	if (node->streamBitmap != NULL)
+	{
+		pfree(node->streamBitmap);
+		node->streamBitmap = NULL;
+	}
 }
 
 void
@@ -218,5 +308,13 @@
 		 * any outer tuple that might be used in index quals.
 		 */
 		ExecReScan(subnode, exprCtxt);
+
+		node->isStream[i] = true;
+	}
+
+	if (node->streamBitmap != NULL)
+	{
+		pfree(node->streamBitmap);
+		node->streamBitmap = NULL;
 	}
 }
diff -Naur src.pgsql/backend/executor/nodeBitmapHeapscan.c src.bitmap/backend/executor/nodeBitmapHeapscan.c
--- src.pgsql/backend/executor/nodeBitmapHeapscan.c	2006-09-16 17:51:41.000000000 -0700
+++ src.bitmap/backend/executor/nodeBitmapHeapscan.c	2006-09-17 00:09:24.000000000 -0700
@@ -59,10 +59,12 @@
 	ExprContext *econtext;
 	HeapScanDesc scan;
 	Index		scanrelid;
-	TIDBitmap  *tbm;
+	Node  		*tbm;
 	TBMIterateResult *tbmres;
 	OffsetNumber targoffset;
 	TupleTableSlot *slot;
+	bool		more = true;
+	bool		done = false;	/* there are no more tuples */
 
 	/*
 	 * extract necessary information from index scan node
@@ -104,121 +106,162 @@
 		return slot;
 	}
 
-	/*
-	 * If we haven't yet performed the underlying index scan, do it, and
-	 * prepare the bitmap to be iterated over.
-	 */
-	if (tbm == NULL)
+	while (!done)
 	{
-		tbm = (TIDBitmap *) MultiExecProcNode(outerPlanState(node));
+		bool	startIterating = false;
 
-		if (!tbm || !IsA(tbm, TIDBitmap))
-			elog(ERROR, "unrecognized result from subplan");
+		/*
+		 * If we haven't yet performed the underlying index scan, or
+		 * we have used up the bitmaps from the previous scan, do the next scan,
+		 * and prepare the bitmap to be iterated over.
+	 	 */
+		if (tbm == NULL)
+		{
+			tbm = (Node *) MultiExecProcNode(outerPlanState(node));
 
-		node->tbm = tbm;
-		node->tbmres = tbmres = NULL;
+			if ((tbm != NULL) &&
+			    !(IsA(tbm, HashBitmap) ||
+			      IsA(tbm, StreamBitmap)))
+				elog(ERROR, "unrecognized result from subplan");
 
-		tbm_begin_iterate(tbm);
-	}
+			/* If tbm is NULL, the scan is over. */
+			if (tbm == NULL)
+				return ExecClearTuple(slot);
 
-	for (;;)
-	{
-		Page		dp;
-		ItemId		lp;
+			node->tbm = tbm;
 
-		/*
-		 * Get next page of results if needed
-		 */
-		if (tbmres == NULL)
+			more = false;
+			startIterating = true;
+		}
+
+		for (;;)
 		{
-			node->tbmres = tbmres = tbm_iterate(tbm);
-			if (tbmres == NULL)
+			Page		dp;
+			ItemId		lp;
+
+			if (!startIterating && tbmres->ntuples == 0)
+				more = false;
+
+			/*
+			 * Get next page of results if needed
+		 	*/
+			if (!more)
+			{
+				more = tbm_iterate(tbm, tbmres);
+				if (!more)
+				{
+					/*
+					 * If no more entries during the first iteration, or
+					 * this is not iterating ondisk bitmaps, we are done.
+					 */
+					if (startIterating || IsA(tbm, HashBitmap))
+						done = true;
+
+					/* no more entries in the bitmap */
+					tbm = NULL;
+
+					break;
+				}
+
+				/*
+				 * Ignore any claimed entries past what we think is the end of the
+				 * relation.  (This is probably not necessary given that we got at
+				 * least AccessShareLock on the table before performing any of the
+				 * indexscans, but let's be safe.)
+				 */
+				if (tbmres->blockno >= scan->rs_nblocks)
+				{
+					more = false;
+
+					if (IsA(tbm, StreamBitmap))
+					{
+						tbm = NULL;
+						break;
+					}
+
+					else
+						continue;
+				}
+
+				/*
+				 * Fetch the current heap page and identify candidate tuples.
+				 */
+				bitgetpage(scan, tbmres);
+
+				/*
+			 	* Set rs_cindex to first slot to examine
+			 	*/
+				scan->rs_cindex = 0;
+			}
+			else
 			{
-				/* no more entries in the bitmap */
-				break;
+				/*
+				 * Continuing in previously obtained page; advance rs_cindex
+				 */
+				scan->rs_cindex++;
+				tbmres->ntuples--;
 			}
 
 			/*
-			 * Ignore any claimed entries past what we think is the end of the
-			 * relation.  (This is probably not necessary given that we got at
-			 * least AccessShareLock on the table before performing any of the
-			 * indexscans, but let's be safe.)
+			 * Out of range?  If so, nothing more to look at on this page
 			 */
-			if (tbmres->blockno >= scan->rs_nblocks)
+			if (scan->rs_cindex < 0 || scan->rs_cindex >= scan->rs_ntuples)
 			{
-				node->tbmres = tbmres = NULL;
-				continue;
+				more = false;
+				tbmres->ntuples = 0;
+				if (IsA(tbm, StreamBitmap))
+				{
+					tbm = NULL;
+					break;
+				}
+
+				else
+					continue;
 			}
 
 			/*
-			 * Fetch the current heap page and identify candidate tuples.
+			 * Okay to fetch the tuple
 			 */
-			bitgetpage(scan, tbmres);
+			targoffset = scan->rs_vistuples[scan->rs_cindex];
+			dp = (Page) BufferGetPage(scan->rs_cbuf);
+			lp = PageGetItemId(dp, targoffset);
+			Assert(ItemIdIsUsed(lp));
+
+			scan->rs_ctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
+			scan->rs_ctup.t_len = ItemIdGetLength(lp);
+			ItemPointerSet(&scan->rs_ctup.t_self, tbmres->blockno, targoffset);
+
+			pgstat_count_heap_fetch(&scan->rs_pgstat_info);
 
 			/*
-			 * Set rs_cindex to first slot to examine
+			 * Set up the result slot to point to this tuple. Note that the
+			 * slot acquires a pin on the buffer.
 			 */
-			scan->rs_cindex = 0;
-		}
-		else
-		{
+			ExecStoreTuple(&scan->rs_ctup,
+						   slot,
+						   scan->rs_cbuf,
+						   false);
+
 			/*
-			 * Continuing in previously obtained page; advance rs_cindex
+			 * If we are using lossy info, we have to recheck the qual
+			 * conditions at every tuple.
 			 */
-			scan->rs_cindex++;
-		}
-
-		/*
-		 * Out of range?  If so, nothing more to look at on this page
-		 */
-		if (scan->rs_cindex < 0 || scan->rs_cindex >= scan->rs_ntuples)
-		{
-			node->tbmres = tbmres = NULL;
-			continue;
-		}
-
-		/*
-		 * Okay to fetch the tuple
-		 */
-		targoffset = scan->rs_vistuples[scan->rs_cindex];
-		dp = (Page) BufferGetPage(scan->rs_cbuf);
-		lp = PageGetItemId(dp, targoffset);
-		Assert(ItemIdIsUsed(lp));
-
-		scan->rs_ctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
-		scan->rs_ctup.t_len = ItemIdGetLength(lp);
-		ItemPointerSet(&scan->rs_ctup.t_self, tbmres->blockno, targoffset);
-
-		pgstat_count_heap_fetch(&scan->rs_pgstat_info);
-
-		/*
-		 * Set up the result slot to point to this tuple. Note that the
-		 * slot acquires a pin on the buffer.
-		 */
-		ExecStoreTuple(&scan->rs_ctup,
-					   slot,
-					   scan->rs_cbuf,
-					   false);
-
-		/*
-		 * If we are using lossy info, we have to recheck the qual
-		 * conditions at every tuple.
-		 */
-		if (tbmres->ntuples < 0)
-		{
-			econtext->ecxt_scantuple = slot;
-			ResetExprContext(econtext);
-
-			if (!ExecQual(node->bitmapqualorig, econtext, false))
+			if (tbmres->ntuples < 0)
 			{
-				/* Fails recheck, so drop it and loop back for another */
-				ExecClearTuple(slot);
-				continue;
+				econtext->ecxt_scantuple = slot;
+				ResetExprContext(econtext);
+
+				if (!ExecQual(node->bitmapqualorig, econtext, false))
+				{
+					/* Fails recheck, so drop it and loop back for another */
+					ExecClearTuple(slot);
+					continue;
+				}
 			}
-		}
 
-		/* OK to return this tuple */
-		return slot;
+			/* OK to return this tuple */
+			return slot;
+		}
 	}
 
 	/*
@@ -390,10 +433,8 @@
 	/* undo bogus "seq scan" count (see notes in ExecInitBitmapHeapScan) */
 	pgstat_discount_heap_scan(&node->ss.ss_currentScanDesc->rs_pgstat_info);
 
-	if (node->tbm)
-		tbm_free(node->tbm);
 	node->tbm = NULL;
-	node->tbmres = NULL;
+	node->tbmres->ntuples = 0;
 
 	/*
 	 * Always rescan the input immediately, to ensure we can pass down any
@@ -435,12 +476,6 @@
 	ExecEndNode(outerPlanState(node));
 
 	/*
-	 * release bitmap if any
-	 */
-	if (node->tbm)
-		tbm_free(node->tbm);
-
-	/*
 	 * close heap scan
 	 */
 	heap_endscan(scanDesc);
@@ -449,6 +484,8 @@
 	 * close the heap relation.
 	 */
 	ExecCloseScanRelation(relation);
+
+	pfree(node->tbmres);
 }
 
 /* ----------------------------------------------------------------
@@ -480,7 +517,8 @@
 	scanstate->ss.ps.state = estate;
 
 	scanstate->tbm = NULL;
-	scanstate->tbmres = NULL;
+	scanstate->tbmres = palloc(sizeof(TBMIterateResult) +
+							   MAX_TUPLES_PER_PAGE * sizeof(OffsetNumber));
 
 	/*
 	 * Miscellaneous initialization
diff -Naur src.pgsql/backend/executor/nodeBitmapIndexscan.c src.bitmap/backend/executor/nodeBitmapIndexscan.c
--- src.pgsql/backend/executor/nodeBitmapIndexscan.c	2006-09-16 17:51:41.000000000 -0700
+++ src.bitmap/backend/executor/nodeBitmapIndexscan.c	2006-09-17 00:09:24.000000000 -0700
@@ -37,13 +37,11 @@
 Node *
 MultiExecBitmapIndexScan(BitmapIndexScanState *node)
 {
-#define MAX_TIDS	1024
-	TIDBitmap  *tbm;
 	IndexScanDesc scandesc;
-	ItemPointerData tids[MAX_TIDS];
-	int32		ntids;
-	double		nTuples = 0;
 	bool		doscan;
+	HashBitmap  *prevHashBitmap;
+	Node 		*bitmap = NULL;
+	BlockNumber	nextBlockNo;
 
 	/* must provide our own instrumentation support */
 	if (node->ss.ps.instrument)
@@ -69,52 +67,48 @@
 	else
 		doscan = true;
 
-	/*
-	 * Prepare the result bitmap.  Normally we just create a new one to pass
-	 * back; however, our parent node is allowed to store a pre-made one into
-	 * node->biss_result, in which case we just OR our tuple IDs into the
-	 * existing bitmap.  (This saves needing explicit UNION steps.)
-	 */
-	if (node->biss_result)
-	{
-		tbm = node->biss_result;
-		node->biss_result = NULL;		/* reset for next time */
-	}
+	if (node->streamBitmap == NULL)
+		nextBlockNo = 0;
 	else
-	{
-		/* XXX should we use less than work_mem for this? */
-		tbm = tbm_create(work_mem * 1024L);
-	}
+		nextBlockNo = node->streamBitmap->nextBlockNo;
 
-	/*
-	 * Get TIDs from index and insert into bitmap
-	 */
+	prevHashBitmap = node->hashBitmap;
+
+	/* Get bitmap from index */
 	while (doscan)
 	{
-		bool		more = index_getmulti(scandesc, tids, MAX_TIDS, &ntids);
+		bitmap = index_getbitmap(scandesc, node->hashBitmap, nextBlockNo);
 
-		if (ntids > 0)
-		{
-			tbm_add_tuples(tbm, tids, ntids);
-			nTuples += ntids;
-		}
+		if ((bitmap != NULL) &&
+			!(IsA(bitmap, HashBitmap) ||
+			  IsA(bitmap, StreamBitmap)))
+			elog(ERROR, "unrecognized result from bitmap index scan");
 
 		CHECK_FOR_INTERRUPTS();
 
-		if (!more)
+		if ((bitmap != NULL) && IsA(bitmap, StreamBitmap))
 		{
-			doscan = ExecIndexAdvanceArrayKeys(node->biss_ArrayKeys,
-											   node->biss_NumArrayKeys);
-			if (doscan)			/* reset index scan */
-				index_rescan(node->biss_ScanDesc, node->biss_ScanKeys);
+			node->streamBitmap = (StreamBitmap*)bitmap;
+			break;
+		} else if (bitmap != NULL) {
+			node->hashBitmap = (HashBitmap*)bitmap;
 		}
+
+		doscan = ExecIndexAdvanceArrayKeys(node->biss_ArrayKeys,
+											   node->biss_NumArrayKeys);
+		if (doscan)			/* reset index scan */
+			index_rescan(node->biss_ScanDesc, node->biss_ScanKeys);
 	}
 
+	/* reset node->hashBitmap */
+	if (prevHashBitmap != NULL)
+		node->hashBitmap = NULL;
+
 	/* must provide our own instrumentation support */
 	if (node->ss.ps.instrument)
-		InstrStopNode(node->ss.ps.instrument, nTuples);
+		InstrStopNode(node->ss.ps.instrument, 0 /* XXX */);
 
-	return (Node *) tbm;
+	return (Node *) bitmap;
 }
 
 /* ----------------------------------------------------------------
@@ -171,6 +165,12 @@
 	/* reset index scan */
 	if (node->biss_RuntimeKeysReady)
 		index_rescan(node->biss_ScanDesc, node->biss_ScanKeys);
+
+	/* reset hashBitmap */
+	if (node->hashBitmap != NULL) {
+		tbm_free(node->hashBitmap);
+		node->hashBitmap = NULL;
+	}
 }
 
 /* ----------------------------------------------------------------
@@ -201,7 +201,11 @@
 	 * close the index relation
 	 */
 	index_endscan(indexScanDesc);
+
 	index_close(indexRelationDesc, NoLock);
+
+	if (node->hashBitmap != NULL)
+		tbm_free(node->hashBitmap);
 }
 
 /* ----------------------------------------------------------------
@@ -226,9 +230,6 @@
 	indexstate->ss.ps.plan = (Plan *) node;
 	indexstate->ss.ps.state = estate;
 
-	/* normally we don't make the result bitmap till runtime */
-	indexstate->biss_result = NULL;
-
 	/*
 	 * Miscellaneous initialization
 	 *
@@ -309,13 +310,21 @@
 
 	/*
 	 * Initialize scan descriptor.
+	 *
+	 * Note we acquire no locks here; the index machinery does its own locks
+	 * and unlocks.  (We rely on having a lock on the parent table to
+	 * ensure the index won't go away!)  Furthermore, if the parent table
+	 * is one of the target relations of the query, then InitPlan already
+	 * opened and write-locked the index, so we can tell the index machinery
+	 * not to bother getting an extra lock.
 	 */
-	indexstate->biss_ScanDesc =
-		index_beginscan_multi(indexstate->biss_RelationDesc,
-							  estate->es_snapshot,
-							  indexstate->biss_NumScanKeys,
-							  indexstate->biss_ScanKeys);
+	relistarget = ExecRelationIsTargetRelation(estate, node->scan.scanrelid);
 
+	indexstate->biss_ScanDesc =
+		index_beginscan_bitmap(indexstate->biss_RelationDesc,
+							   estate->es_snapshot,
+							   indexstate->biss_NumScanKeys,
+							   indexstate->biss_ScanKeys);
 	/*
 	 * all done.
 	 */
diff -Naur src.pgsql/backend/executor/nodeBitmapOr.c src.bitmap/backend/executor/nodeBitmapOr.c
--- src.pgsql/backend/executor/nodeBitmapOr.c	2006-09-16 17:51:41.000000000 -0700
+++ src.bitmap/backend/executor/nodeBitmapOr.c	2006-09-17 00:09:24.000000000 -0700
@@ -81,14 +81,19 @@
 	 * call ExecInitNode on each of the plans to be executed and save the
 	 * results into the array "bitmapplanstates".
 	 */
+	bitmaporstate->isStream = (bool*)palloc(nplans);
 	i = 0;
 	foreach(l, node->bitmapplans)
 	{
 		initNode = (Plan *) lfirst(l);
 		bitmapplanstates[i] = ExecInitNode(initNode, estate, eflags);
+		bitmaporstate->isStream[i] = true;
 		i++;
 	}
 
+	bitmaporstate->hashBitmap = NULL;
+	bitmaporstate->streamBitmap = NULL;
+
 	return bitmaporstate;
 }
 
@@ -113,7 +118,9 @@
 	PlanState **bitmapplans;
 	int			nplans;
 	int			i;
-	TIDBitmap  *result = NULL;
+	List		*streamBitmaps = NIL;
+	BlockNumber	blockno = InvalidBlockNumber;
+	bool		outputIsStream = false;
 
 	/* must provide our own instrumentation support */
 	if (node->ps.instrument)
@@ -131,55 +138,85 @@
 	for (i = 0; i < nplans; i++)
 	{
 		PlanState  *subnode = bitmapplans[i];
-		TIDBitmap  *subresult;
+		Node	   *subresult = NULL;
 
-		/*
-		 * We can special-case BitmapIndexScan children to avoid an explicit
-		 * tbm_union step for each child: just pass down the current result
-		 * bitmap and let the child OR directly into it.
-		 */
 		if (IsA(subnode, BitmapIndexScanState))
+			((BitmapIndexScanState *) subnode)->hashBitmap = node->hashBitmap;
+
+		if (node->isStream[i])
+			subresult = MultiExecProcNode(subnode);
+
+		if ((subresult != NULL) &&
+			!(IsA(subresult, HashBitmap) ||
+			  IsA(subresult, StreamBitmap)))
+			elog(ERROR, "unrecognized result from subplan");
+
+		if ((subresult != NULL) && IsA(subresult, HashBitmap))
 		{
-			if (result == NULL) /* first subplan */
+			node->isStream[i] = false;
+			if (!IsA(subnode, BitmapIndexScanState))
 			{
-				/* XXX should we use less than work_mem for this? */
-				result = tbm_create(work_mem * 1024L);
+				if (node->hashBitmap == NULL)
+					node->hashBitmap = (HashBitmap*)subresult;
+				else
+				{
+					tbm_union(node->hashBitmap, (HashBitmap*)subresult);
+					tbm_free((HashBitmap*)subresult);
+				}
 			}
 
-			((BitmapIndexScanState *) subnode)->biss_result = result;
-
-			subresult = (TIDBitmap *) MultiExecProcNode(subnode);
-
-			if (subresult != result)
-				elog(ERROR, "unrecognized result from subplan");
+			else
+				node->hashBitmap = (HashBitmap*)subresult;
 		}
-		else
+		else if (subresult != NULL)
 		{
-			/* standard implementation */
-			subresult = (TIDBitmap *) MultiExecProcNode(subnode);
+			Assert(blockno == InvalidBlockNumber ||
+				   blockno == ((StreamBitmap*)subresult)->entry.blockno);
+			blockno = ((StreamBitmap*)subresult)->entry.blockno;
+			streamBitmaps = lappend(streamBitmaps, subresult);
+		}
+	}		
 
-			if (!subresult || !IsA(subresult, TIDBitmap))
-				elog(ERROR, "unrecognized result from subplan");
+	/* Union stream bitmaps if any */
+	if (streamBitmaps != NIL)
+	{
+		if (node->hashBitmap != NULL)
+		{
+			StreamBitmap*	streamBitmap;
+			Assert(blockno != InvalidBlockNumber);
+			streamBitmap =
+				tbm_hash_to_stream(node->hashBitmap, blockno);
 
-			if (result == NULL)
-				result = subresult;		/* first subplan */
-			else
-			{
-				tbm_union(result, subresult);
-				tbm_free(subresult);
-			}
+			if (streamBitmap != NULL)
+				streamBitmaps = lappend(streamBitmaps, streamBitmap);
 		}
-	}
 
-	/* We could return an empty result set here? */
-	if (result == NULL)
-		elog(ERROR, "BitmapOr doesn't support zero inputs");
+		tbm_construct_stream_or(streamBitmaps, &(node->streamBitmap));
+		outputIsStream = true;
+
+		list_free(streamBitmaps);
+		streamBitmaps = NIL;
+	}
 
 	/* must provide our own instrumentation support */
 	if (node->ps.instrument)
 		InstrStopNode(node->ps.instrument, 0 /* XXX */ );
 
-	return (Node *) result;
+	if (outputIsStream)
+		return (Node *) node->streamBitmap;
+	else
+	{
+		HashBitmap *hashBitmap = node->hashBitmap;
+
+		/*
+		 *set node->hashBitmap to NULL since this node will not be
+		 * called any more and its space will be re-claimed in its
+		 * parent node.
+		 */
+		node->hashBitmap = NULL;
+
+		return (Node*) hashBitmap;
+	}
 }
 
 /* ----------------------------------------------------------------
@@ -211,6 +248,14 @@
 		if (bitmapplans[i])
 			ExecEndNode(bitmapplans[i]);
 	}
+
+	pfree(node->isStream);
+
+	if (node->streamBitmap != NULL)
+	{
+		pfree(node->streamBitmap);
+		node->streamBitmap = NULL;
+	}
 }
 
 void
@@ -234,5 +279,13 @@
 		 * any outer tuple that might be used in index quals.
 		 */
 		ExecReScan(subnode, exprCtxt);
+
+		node->isStream[i] = true;
+	}
+
+	if (node->streamBitmap != NULL)
+	{
+		pfree(node->streamBitmap);
+		node->streamBitmap = NULL;
 	}
 }
